# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_softwareinstall`](#dsc_softwareinstall): The DSC SoftwareInstall resource type. Automatically generated from version 0.6

## Resource types

### <a name="dsc_softwareinstall"></a>`dsc_softwareinstall`

The DSC SoftwareInstall resource type.
Automatically generated from version 0.6

#### Properties

The following properties are available in the `dsc_softwareinstall` type.

##### `dsc_algorithm`

Data type: `Optional[Enum['None', 'SHA1', 'SHA256', 'SHA384', 'SHA512', 'MACTripleDES', 'MD5', 'RIPEMD160']]`

Specifies the checksum type to verify the downloaded file

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Says whether DestinationPath exists on the machine.

##### `dsc_hash`

Data type: `Optional[String]`

Specifies the checksum value to compare against the downloaded file.

##### `dsc_ignorereboot`

Data type: `Optional[Boolean]`

Specifies that we will not instruct DSC to trigger a reboot on exit code 3010.

##### `dsc_installcommand`

Data type: `Optional[String]`

Install command for software package. The following string replacements will be performed: {0} = Installer File, {1} = Log File, {2} = Package Id (as detected in Uninstall entry).

##### `dsc_logpath`

Data type: `Optional[String]`

Specifies path to log file.

##### `dsc_proxy`

Data type: `Optional[String]`

Specifies the proxy to use when sending the request.

##### `dsc_proxyusedefaultcredential`

Data type: `Optional[Boolean]`

Specifies to use the Default Credential to access the proxy.

##### `dsc_publisher`

Data type: `Optional[String]`

Name of the publisher of the software to be installed. Should match value in Add/Remove Programs. Wildcards are supported.

##### `dsc_requirevalidsignature`

Data type: `Optional[Boolean]`

Requite valid signing certificate on the installer. Implied TRUE if Subject or Thumbprint are validated.

##### `dsc_returncode`

Data type: `Optional[Array[Integer[0, 4294967295]]]`

Valid return codes for the install command. Default is 0, 1641, and 3010.

##### `dsc_servercertificatevalidationcallback`

Data type: `Optional[String]`

Callback scriptblock used to validate server certificate of server when downloading over HTTPS or FTPS.

##### `dsc_subject`

Data type: `Optional[String]`

Subject name of signing certificate used for installer. Wildcards are supported.

##### `dsc_thumbprint`

Data type: `Optional[String]`

Thumbprint of the signing certificate used for installer. Wildcards are supported.

##### `dsc_timeoutseconds`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how long the request can be pending before it times out.

##### `dsc_type`

Data type: `Enum['MSI', 'EXE']`

Type of installer package.

##### `dsc_uninstallcommand`

Data type: `Optional[String]`

Uninstall command for software package. The following string replacements will be performed: {0} = Installer File, {1} = Log File, {2} = Package Id (as detected in Uninstall entry).

##### `dsc_uninstallrequiresinstaller`

Data type: `Optional[Boolean]`

Installer is required for uninstall command. Keeps cached files, or downloads installer if cache is missing.

##### `dsc_uninstallreturncode`

Data type: `Optional[Array[Integer[0, 4294967295]]]`

Valid return codes for the uninstall command. Default is 0 and 3010.

##### `dsc_uri`

Data type: `String`

Uri of a file which should be copied or downloaded. This parameter supports HTTP, HTTPS, FTP, and FILE values.

##### `dsc_usedefaultcredential`

Data type: `Optional[Boolean]`

Specifies to use the Default Credential to send the request.

##### `dsc_version`

Data type: `Optional[String]`

Version of the software to be installed. Should match value in Add/Remove Programs.

##### `dsc_versioncomparison`

Data type: `Optional[Enum['Any', 'LessThan', 'LessThanOrEqualTo', 'EqualTo', 'GreaterThanOrEqualTo', 'GreaterThan']]`

How the version is compared to the installed version. Defaults to EqualTo.

#### Parameters

The following parameters are available in the `dsc_softwareinstall` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_name`](#dsc_name)
* [`dsc_proxycredential`](#dsc_proxycredential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_runascredential`](#dsc_runascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies a user account that has permission to send the request.

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the software to be installed. Should match name in Add/Remove Programs. Wildcards are supported.

##### <a name="dsc_proxycredential"></a>`dsc_proxycredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies a user account that has permission to access the proxy.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_runascredential"></a>`dsc_runascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the credential to use when running the installer.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

